/*****************************************************************************/
/*                                                                           */
/* FILENAME                                                                  */
/* 	 main.c                                                                  */
/*                                                                           */
/* DESCRIPTION                                                               */
/*   TMS320C5515 USB Stick Application 20 Spectrum Analyser.                 */
/*   Take microphone input and send to headphones with ring modulation.      */
/*                                                                           */
/* REVISION                                                                  */
/*   Revision: 1.00	                                                         */
/*   Author  : Richard Sikora                                                */
/*---------------------------------------------------------------------------*/
/*                                                                           */
/* HISTORY                                                                   */
/*   Revision: 1.00                                                          */
/*   15th September 2010. Created from TMS320C5505 USB Stick code.           */
/*                                                                           */
/*****************************************************************************/
/*
 * Copyright (C) 2010 Texas Instruments Incorporated - http://www.ti.com/ 
 * 
 * 
 *  Redistribution and use in source and binary forms, with or without 
 *  modification, are permitted provided that the following conditions 
 *  are met:
 *
 *    Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the 
 *    documentation and/or other materials provided with the   
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
*/

#include "stdio.h"
#include "usbstk5515.h"
#include "usbstk5515_led.h"
#include "aic3204.h"
#include "PLL.h"
#include "oled.h"
#include "pushbuttons.h"
#include "stereo.h"
#include "dsplib.h"
#include "sinewaves.h"
#include "math.h"
#include "gsm.h"

#include "combfilters.h"
#include "IIR_filters_fourth_order.h"
#include "IIR_low_pass_filters.h"

Int16 left_input;
Int16 right_input;
Int16 left_output;
Int16 right_output;

#define SAMPLES_PER_SECOND 48000
#define GAIN_IN_dB 0

int fo = 12000;		// częstotliwość VCO
double f3dB = 10;	// pasmo filtru sprzężenia zwrotnego

int PSK;
int nosna_cos = 100;
int nosna_sin = 0;
int iloczyn1 = 1000;
int iloczyn2 = 1000;
int out1 = 10;
int out2 = 10;
int out1x2 = 10;
int feedback = 100;
int dem_PSK_bity;

double ALFA,  ALFA_F;
double omega3dB;

const signed int *wspLP;

unsigned int Step = 0; 
unsigned int LastStep = 99;

/* ------------------------------------------------------------------------ *
 *                                                                          *
 *  main( )                                                                 *
 *                                                                          *
 * ------------------------------------------------------------------------ */
void main( void ) 
{
    /* Initialize BSL */
    USBSTK5515_init( );
	
	/* Initialize PLL */
	pll_frequency_setup(120);

    /* Initialise hardware interface and I2C for code */
    aic3204_hardware_init();
    
    /* Initialise the AIC3204 codec */
	aic3204_init(); 
	
	/* Turn off the 4 coloured LEDs */
	USBSTK5515_ULED_init();
	
	/* Initialise the OLED LCD display */
	oled_init();
	SAR_init();
	/* Flush display buffer */
    oled_display_message("                 ", "                   ");
    
    printf("\n\nLaboratorium FCiPS\n");
    printf( "Demodulator z pętlą Costasa\n" );

	/* Setup sampling frequency and  gain for microphone */
    set_sampling_frequency_and_gain(SAMPLES_PER_SECOND, GAIN_IN_dB);

    oled_display_message("Laboratorium FCiPS ", "petla pll costasa  ");

	/* New. Add descriptive text */ 
	puts("\n Pętla PLL Costasa");
    puts("\n Wciśnij SW1 <-- , SW2 -->, SW1 + SW2 for reset\n");
    printf("fo = %5d ", fo);
    puts("\n Step 1   = Straight through, no signal processing. Set levels");
   
     
	/* Default to XF LED off */
	asm(" bclr XF");
	
	//fo = 10000;			// częstotliwość VCO
   
   	f3dB = 5;			// pasmo filtru sprzężenia zwrotnego
    omega3dB = 2*3.1415926*f3dB/SAMPLES_PER_SECOND;
    ALFA = (1.0 - sin(omega3dB))/cos(omega3dB);
    f3dB = 1;			// pasmo filtru sprzężenia zwrotnego
    omega3dB = 2*3.1415926*f3dB/SAMPLES_PER_SECOND;
    ALFA_F = (1.0 - sin(omega3dB))/cos(omega3dB);
    
    wspLP = IIR_low_pass_2400Hz;
    //wspLP = IIR_low_pass_4800Hz;
        
 	for ( ;; )
 	{
     aic3204_codec_read(&left_input, &right_input); // Configured for one interrupt per two channels.
     PSK = left_input;
	  
     // PLL 
     //VCO(fo + (feedback >> 0), 30000, &nosna_sin, &nosna_cos);
     //VCO90delta(fo, (feedback >> 0), 30000, &nosna_sin, &nosna_cos);
     VCO90deltaLongBPSK(fo, feedback >> 4, 30000, &nosna_sin, &nosna_cos);
     
     
     //iloczyn1 = ((long)PSK * nosna_cos) >> 15;		// detektor fazy 1   
     //iloczyn2 = ((long)PSK * nosna_sin) >> 15;		// detektor fazy 2
     
     iloczyn1 = _smpyr(PSK, nosna_cos) >> 16;		// detektor fazy 1   
     iloczyn2 = _smpyr(PSK, nosna_sin) >> 16;		// detektor fazy 2     

     out1 = second_order_IIR_direct_form_I (wspLP, iloczyn1);  //filtr dolnoprzepustowy 1 
     out2 = second_order_IIR_direct_form_IA(wspLP, iloczyn2); //filtr dolnoprzepustowy 2 
     
     //out1x2 = ((long)out1 * out2) >> 13;				// można 13 bo po filrtacji składowe * 0.5
	 //out1x2 = ((long)out1 * out2) >> 12;
	 
	 out1x2 = L_crshft_r((long)out1 * out2, 13);

	 
	 

     //feedback = LP(out1x2, 1, ALFA); 		//filtr dolnoprzepustowy sprzężenia zwrotnego
     feedback = LP_I(out1x2, ALFA_F);
     feedback = LP_A(feedback, ALFA);
     //feedback = feedback << 1;     
     //feedback = _shrs(feedback, 6);
     // PLL koniec
	
	 if(out2 > 0) dem_PSK_bity = 20000; else dem_PSK_bity = -20000;    
               
     Step = pushbuttons_read(8);
         
	  if ( Step == 1 )
        {
         if ( Step != LastStep )
          {
           oled_display_message("L = PSK           ", "P = nosna cos     ");
           LastStep = Step;
          }	
         left_output = PSK;      
	     right_output = nosna_cos;
	    } 
	    
	    if ( Step == 2)
        {
         if ( Step != LastStep )
          {
           oled_display_message("L = nosna sin     ", "P = kanal prawy   ");
           LastStep = Step;
          }	
         left_output = nosna_sin;     
	     right_output = right_input;	
	    }
	       
	    if ( Step == 3)
        {
         if ( Step != LastStep )
          {
           oled_display_message("L = nosna_sin         ", "P = nosna cos     ");
           LastStep = Step;
          }	
         left_output = nosna_sin;     
	     right_output = nosna_cos;	
	    } 
	      
	    if ( Step == 4)
        {
         if ( Step != LastStep )
          {
            oled_display_message("L = iloczynin 1   ", "P = iloczynin 2   ");          
            LastStep = Step;
          }         
         left_output = iloczyn1;
	     right_output = iloczyn2;	
	    }
	    
	    if ( Step == 5)
        {
         if ( Step != LastStep )
          {
            oled_display_message("L = out1          ", "P = out2          ");          
            LastStep = Step;
          }         
         left_output = out1;
	     right_output = out2;	
	    }
	     
	    if ( Step == 6)
        {
         if ( Step != LastStep )
          {
            oled_display_message("L = feedback      ", "P = out1 x out2   ");          
            LastStep = Step;
          }         
         left_output = feedback;
	     right_output = out1x2;	
	    }
	    
	    if ( Step == 7)
        {
         if ( Step != LastStep )
          {
            oled_display_message("L = out2          ", "P = dem psk bity  ");          
            LastStep = Step;
          }         
         left_output = out2;
	     right_output = dem_PSK_bity;	
	    }  
	    
	    if ( Step == 8)
        {
         if ( Step != LastStep )
          {	 
            oled_display_message("patrz na konsole  ", "i wpisz fo dla VCO");
            printf("Podaj częstotliwość VCO fo = ");
    		scanf("%d", &fo); 
    		if(fo <= 3000)  			wspLP = IIR_low_pass_4000Hz; 
            if(fo > 3000 && fo < 12000) wspLP = IIR_low_pass_4800Hz; 
            if(fo >= 12000) 			wspLP = IIR_low_pass_9600Hz;      
            LastStep = Step;
          }         
         left_output = PSK;      
	     right_output = nosna_cos;
	    }  
	    	    
     aic3204_codec_write(left_output, right_output);

 	}

   /* Disable I2S and put codec into reset */ 
    aic3204_disable();

    printf( "\n***Program has Terminated***\n" );
    
    oled_display_message("PROGRAM HAS        ", "TERMINATED        ");
    
    SW_BREAKPOINT;
}

/* ------------------------------------------------------------------------ *
 *                                                                          *
 *  End of main.c                                                           *
 *                                                                          *
 * ------------------------------------------------------------------------ */
